#include <msp/graphics/window_private.h>
#include "mouse.h"

namespace Msp {
namespace Input {

void Mouse::input_event(const Graphics::Window::Event &event)
{
	switch(event.cevent.type)
	{
	case LEFT_MOUSE_DOWN:
	case LEFT_MOUSE_UP:
	case RIGHT_MOUSE_DOWN:
	case RIGHT_MOUSE_UP:
	case OTHER_MOUSE_DOWN:
	case OTHER_MOUSE_UP:
		set_button_state(event.cevent.button.button, event.cevent.button.state, true);
		break;
	case MOUSE_MOVED:
		set_axis_value(0, event.cevent.motion.x*2.0/window.get_width()-1.0, true);
		set_axis_value(1, event.cevent.motion.y*2.0/window.get_height()-1.0, true);
		break;
	default:;
	}
}

} // namespace Input
} // namespace Msp
